<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): TIGLCommunicationManager&lt; SUBGRAPH_TYPE &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classtiglCommunicationManager-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">TIGLCommunicationManager&lt; SUBGRAPH_TYPE &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__comm__module.html">Communication</a> &#124; <a class="el" href="group__comm__engine.html">Communication Engine</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>core communicator class definition  
 <a href="classtiglCommunicationManager.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglCommunicationManager_8hpp_source.html">tiglCommunicationManager.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ad495e4583bb9306f63958d65add2588e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad495e4583bb9306f63958d65add2588e"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#ad495e4583bb9306f63958d65add2588e">TIGLCommunicationManager</a> ()</td></tr>
<tr class="memdesc:ad495e4583bb9306f63958d65add2588e"><td class="mdescLeft">&#160;</td><td class="mdescRight">empty constructor <br /></td></tr>
<tr class="separator:ad495e4583bb9306f63958d65add2588e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a002a1f09caea60c57aaaf8f320435b26"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a002a1f09caea60c57aaaf8f320435b26">TIGLCommunicationManager</a> (SUBGRAPH_TYPE *<a class="el" href="classtiglCommunicationManager.html#a6bba0215fd671aab95b2faa1f226ac32">dataPtr</a>, uint_fast32_t devices, int <a class="el" href="classtiglCommunicationManager.html#a6a4bba59c0f81cb43ead71b9d753c0ea">rank</a>=0)</td></tr>
<tr class="memdesc:a002a1f09caea60c57aaaf8f320435b26"><td class="mdescLeft">&#160;</td><td class="mdescRight">overloaded constructor constructor  <a href="#a002a1f09caea60c57aaaf8f320435b26">More...</a><br /></td></tr>
<tr class="separator:a002a1f09caea60c57aaaf8f320435b26"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a79cb87ff60961642caeee928f5314682"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a79cb87ff60961642caeee928f5314682"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a79cb87ff60961642caeee928f5314682">~TIGLCommunicationManager</a> ()</td></tr>
<tr class="memdesc:a79cb87ff60961642caeee928f5314682"><td class="mdescLeft">&#160;</td><td class="mdescRight">destructor <br /></td></tr>
<tr class="separator:a79cb87ff60961642caeee928f5314682"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6bb24cbca568ca64067d089fc76e0a2f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6bb24cbca568ca64067d089fc76e0a2f"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a6bb24cbca568ca64067d089fc76e0a2f">reset</a> ()</td></tr>
<tr class="memdesc:a6bb24cbca568ca64067d089fc76e0a2f"><td class="mdescLeft">&#160;</td><td class="mdescRight">reset procedure <br /></td></tr>
<tr class="separator:a6bb24cbca568ca64067d089fc76e0a2f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4d3fc1a14e63b16b413695fe3dd433f2"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a4d3fc1a14e63b16b413695fe3dd433f2">init</a> (SUBGRAPH_TYPE *dPtr, uint_fast32_t devices=1, uint_fast32_t devRank=0)</td></tr>
<tr class="memdesc:a4d3fc1a14e63b16b413695fe3dd433f2"><td class="mdescLeft">&#160;</td><td class="mdescRight">initializes the communicator object  <a href="#a4d3fc1a14e63b16b413695fe3dd433f2">More...</a><br /></td></tr>
<tr class="separator:a4d3fc1a14e63b16b413695fe3dd433f2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7a3f3e74731feba0b7a22e052f7d5aa9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a7a3f3e74731feba0b7a22e052f7d5aa9">initSS</a> ()</td></tr>
<tr class="memdesc:a7a3f3e74731feba0b7a22e052f7d5aa9"><td class="mdescLeft">&#160;</td><td class="mdescRight">initialize the flags of the TX/RX tasks at the start of the superstep  <a href="#a7a3f3e74731feba0b7a22e052f7d5aa9">More...</a><br /></td></tr>
<tr class="separator:a7a3f3e74731feba0b7a22e052f7d5aa9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a53f64b7f8295fc1c5ae23d011d222763"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a53f64b7f8295fc1c5ae23d011d222763">isTxComplete</a> ()</td></tr>
<tr class="memdesc:a53f64b7f8295fc1c5ae23d011d222763"><td class="mdescLeft">&#160;</td><td class="mdescRight">check if all TX messages for the current SS is done  <a href="#a53f64b7f8295fc1c5ae23d011d222763">More...</a><br /></td></tr>
<tr class="separator:a53f64b7f8295fc1c5ae23d011d222763"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac383d378b33c25ac6706d77b3ddb1db9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#ac383d378b33c25ac6706d77b3ddb1db9">endSS</a> ()</td></tr>
<tr class="memdesc:ac383d378b33c25ac6706d77b3ddb1db9"><td class="mdescLeft">&#160;</td><td class="mdescRight">called at the end of the superstep to flag the end of message generation  <a href="#ac383d378b33c25ac6706d77b3ddb1db9">More...</a><br /></td></tr>
<tr class="separator:ac383d378b33c25ac6706d77b3ddb1db9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3906aa6920e8e35ae8fa5fe138aace35"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a3906aa6920e8e35ae8fa5fe138aace35">continuousSendMessages</a> ()</td></tr>
<tr class="memdesc:a3906aa6920e8e35ae8fa5fe138aace35"><td class="mdescLeft">&#160;</td><td class="mdescRight">high-level message TX routine  <a href="#a3906aa6920e8e35ae8fa5fe138aace35">More...</a><br /></td></tr>
<tr class="separator:a3906aa6920e8e35ae8fa5fe138aace35"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a16cf54ffb11033e7ce47748efca136e0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a16cf54ffb11033e7ce47748efca136e0">continuousRecvMessages</a> ()</td></tr>
<tr class="memdesc:a16cf54ffb11033e7ce47748efca136e0"><td class="mdescLeft">&#160;</td><td class="mdescRight">core message receive routine  <a href="#a16cf54ffb11033e7ce47748efca136e0">More...</a><br /></td></tr>
<tr class="separator:a16cf54ffb11033e7ce47748efca136e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a258a92f1d587032e791dab9bd9c9f58c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a258a92f1d587032e791dab9bd9c9f58c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a258a92f1d587032e791dab9bd9c9f58c">printIdleTime</a> ()</td></tr>
<tr class="memdesc:a258a92f1d587032e791dab9bd9c9f58c"><td class="mdescLeft">&#160;</td><td class="mdescRight">profiling function that prints the idle time for each task <br /></td></tr>
<tr class="separator:a258a92f1d587032e791dab9bd9c9f58c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a46f40c9bf3a181764e3d113acd33d0de"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a46f40c9bf3a181764e3d113acd33d0de">setTimePtr</a> (uint_fast32_t *timePtr)</td></tr>
<tr class="memdesc:a46f40c9bf3a181764e3d113acd33d0de"><td class="mdescLeft">&#160;</td><td class="mdescRight">initializes the communicator object  <a href="#a46f40c9bf3a181764e3d113acd33d0de">More...</a><br /></td></tr>
<tr class="separator:a46f40c9bf3a181764e3d113acd33d0de"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aad65887bc9f4f5d7afc869b3b56e510e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aad65887bc9f4f5d7afc869b3b56e510e"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#aad65887bc9f4f5d7afc869b3b56e510e">setNumVertices</a> (uint64_t numVertices)</td></tr>
<tr class="memdesc:aad65887bc9f4f5d7afc869b3b56e510e"><td class="mdescLeft">&#160;</td><td class="mdescRight">passes the total number of vertices in the graph (used in finding the device for each vertex) <br /></td></tr>
<tr class="separator:aad65887bc9f4f5d7afc869b3b56e510e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:add2781f80bf229ca8e379293aceaaf61"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="add2781f80bf229ca8e379293aceaaf61"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#add2781f80bf229ca8e379293aceaaf61">isMultipleDevices</a> ()</td></tr>
<tr class="memdesc:add2781f80bf229ca8e379293aceaaf61"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns true if multiple devices are used, otherwise returns false <br /></td></tr>
<tr class="separator:add2781f80bf229ca8e379293aceaaf61"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae376c35744ea91129ac886f7efffef5a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#ae376c35744ea91129ac886f7efffef5a">sendSysMessages</a> ()</td></tr>
<tr class="memdesc:ae376c35744ea91129ac886f7efffef5a"><td class="mdescLeft">&#160;</td><td class="mdescRight">sending all system messages. This is a blocking function  <a href="#ae376c35744ea91129ac886f7efffef5a">More...</a><br /></td></tr>
<tr class="separator:ae376c35744ea91129ac886f7efffef5a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a818f1980895110689d07094b2bdb8710"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a818f1980895110689d07094b2bdb8710">sendMutationMessages</a> ()</td></tr>
<tr class="memdesc:a818f1980895110689d07094b2bdb8710"><td class="mdescLeft">&#160;</td><td class="mdescRight">sending all mutation messages. This is a blocking function  <a href="#a818f1980895110689d07094b2bdb8710">More...</a><br /></td></tr>
<tr class="separator:a818f1980895110689d07094b2bdb8710"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abcdecfae5eefed5616af3a6f8f036ba9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abcdecfae5eefed5616af3a6f8f036ba9"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#abcdecfae5eefed5616af3a6f8f036ba9">sendInstMutationMessage</a> (int thread)</td></tr>
<tr class="memdesc:abcdecfae5eefed5616af3a6f8f036ba9"><td class="mdescLeft">&#160;</td><td class="mdescRight">sending a single mutation messages. This is a blocking function <br /></td></tr>
<tr class="separator:abcdecfae5eefed5616af3a6f8f036ba9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae27613519573876dd2782f544a3d99b8"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#ae27613519573876dd2782f544a3d99b8">taggedBcast</a> (uint8_t *txBuf, uint_fast32_t bufSize, int tag)</td></tr>
<tr class="memdesc:ae27613519573876dd2782f544a3d99b8"><td class="mdescLeft">&#160;</td><td class="mdescRight">overloaded: sending a single message to a particular destination with a given tag  <a href="#ae27613519573876dd2782f544a3d99b8">More...</a><br /></td></tr>
<tr class="separator:ae27613519573876dd2782f544a3d99b8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a980dda0eb9b713f6da87326334c8cd21"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a980dda0eb9b713f6da87326334c8cd21">instRecvMutationMessages</a> (int dev)</td></tr>
<tr class="memdesc:a980dda0eb9b713f6da87326334c8cd21"><td class="mdescLeft">&#160;</td><td class="mdescRight">core function for receiving all mutation messages from a given device  <a href="#a980dda0eb9b713f6da87326334c8cd21">More...</a><br /></td></tr>
<tr class="separator:a980dda0eb9b713f6da87326334c8cd21"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a93366dc18525e70042dfce7bbdf7004c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a93366dc18525e70042dfce7bbdf7004c"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a93366dc18525e70042dfce7bbdf7004c">getRank</a> ()</td></tr>
<tr class="memdesc:a93366dc18525e70042dfce7bbdf7004c"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the rank of the device <br /></td></tr>
<tr class="separator:a93366dc18525e70042dfce7bbdf7004c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a6305ea643bdd038b2eabba188809229c"><td class="memTemplParams" colspan="2">template&lt;typename MESSAGE_TYPE &gt; </td></tr>
<tr class="memitem:a6305ea643bdd038b2eabba188809229c"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a6305ea643bdd038b2eabba188809229c">bytes2Messages</a> (uint8_t *rxBuf, uint_fast32_t messageSize, vector&lt; MESSAGE_TYPE &gt; &amp;messageBuf)</td></tr>
<tr class="memdesc:a6305ea643bdd038b2eabba188809229c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a sequence of bytes to messages (can be one or more than one messages)  <a href="#a6305ea643bdd038b2eabba188809229c">More...</a><br /></td></tr>
<tr class="separator:a6305ea643bdd038b2eabba188809229c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a05204df283d9a53fa26f8ef6c4d9ec53"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a05204df283d9a53fa26f8ef6c4d9ec53">messages2Bytes</a> (DATA_MESSAGE_BUF_TYPE *messagePtr, uint8_t *outBuf)</td></tr>
<tr class="memdesc:a05204df283d9a53fa26f8ef6c4d9ec53"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a group of data messages to a sequence of bytes to be sent.  <a href="#a05204df283d9a53fa26f8ef6c4d9ec53">More...</a><br /></td></tr>
<tr class="separator:a05204df283d9a53fa26f8ef6c4d9ec53"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a45b756eeec6a8167ae98ed17a9b4070a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a45b756eeec6a8167ae98ed17a9b4070a">processOneMessage</a> (uint8_t *rxBuf, int tag, uint_fast32_t messageSize, uint_fast32_t dev)</td></tr>
<tr class="memdesc:a45b756eeec6a8167ae98ed17a9b4070a"><td class="mdescLeft">&#160;</td><td class="mdescRight">processing a single received message  <a href="#a45b756eeec6a8167ae98ed17a9b4070a">More...</a><br /></td></tr>
<tr class="separator:a45b756eeec6a8167ae98ed17a9b4070a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a65d5d5b5f5d5f1a82fbb375d3faacd79"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a65d5d5b5f5d5f1a82fbb375d3faacd79">countMessages</a> (uint_fast32_t *devMessagesCount)</td></tr>
<tr class="memdesc:a65d5d5b5f5d5f1a82fbb375d3faacd79"><td class="mdescLeft">&#160;</td><td class="mdescRight">count the number of messages to each device  <a href="#a65d5d5b5f5d5f1a82fbb375d3faacd79">More...</a><br /></td></tr>
<tr class="separator:a65d5d5b5f5d5f1a82fbb375d3faacd79"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0b4b3ed59f65b42d13e7f5e41786c9bc"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a0b4b3ed59f65b42d13e7f5e41786c9bc">existDataMessages2Tx</a> ()</td></tr>
<tr class="separator:a0b4b3ed59f65b42d13e7f5e41786c9bc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac3bb92c1a0066c0934aebfa6b4fc3866"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#ac3bb92c1a0066c0934aebfa6b4fc3866">existSysMessages2Tx</a> ()</td></tr>
<tr class="memdesc:ac3bb92c1a0066c0934aebfa6b4fc3866"><td class="mdescLeft">&#160;</td><td class="mdescRight">check if there is any new system message to transmit to other devices  <a href="#ac3bb92c1a0066c0934aebfa6b4fc3866">More...</a><br /></td></tr>
<tr class="separator:ac3bb92c1a0066c0934aebfa6b4fc3866"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaa8a5a2e7a110cbfaf5293d6aab71961"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#aaa8a5a2e7a110cbfaf5293d6aab71961">existMutationMessages2Tx</a> ()</td></tr>
<tr class="memdesc:aaa8a5a2e7a110cbfaf5293d6aab71961"><td class="mdescLeft">&#160;</td><td class="mdescRight">check if there is any new mutation message to transmit to other devices  <a href="#aaa8a5a2e7a110cbfaf5293d6aab71961">More...</a><br /></td></tr>
<tr class="separator:aaa8a5a2e7a110cbfaf5293d6aab71961"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7bca269339a42c1afff19d8228d276ed"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a7bca269339a42c1afff19d8228d276ed">sendDataMessages</a> (bool flushBuffers=false)</td></tr>
<tr class="memdesc:a7bca269339a42c1afff19d8228d276ed"><td class="mdescLeft">&#160;</td><td class="mdescRight">check if there is any new system message to transmit to other devices  <a href="#a7bca269339a42c1afff19d8228d276ed">More...</a><br /></td></tr>
<tr class="separator:a7bca269339a42c1afff19d8228d276ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7e44d1cfb8eb47d84993a31bf549945e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7e44d1cfb8eb47d84993a31bf549945e"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a7e44d1cfb8eb47d84993a31bf549945e">sendMessagesSizes</a> ()</td></tr>
<tr class="memdesc:a7e44d1cfb8eb47d84993a31bf549945e"><td class="mdescLeft">&#160;</td><td class="mdescRight">sending the count of data messages to all devices <br /></td></tr>
<tr class="separator:a7e44d1cfb8eb47d84993a31bf549945e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3f14286c0744fb70b2e6a25b176ca5f8"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a3f14286c0744fb70b2e6a25b176ca5f8">waitAllTx</a> ()</td></tr>
<tr class="memdesc:a3f14286c0744fb70b2e6a25b176ca5f8"><td class="mdescLeft">&#160;</td><td class="mdescRight">waiting for all pending TX messages  <a href="#a3f14286c0744fb70b2e6a25b176ca5f8">More...</a><br /></td></tr>
<tr class="separator:a3f14286c0744fb70b2e6a25b176ca5f8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a364ceba90a34ff3c9f4ddbdddea5c3fb"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a364ceba90a34ff3c9f4ddbdddea5c3fb">findTxSlot</a> ()</td></tr>
<tr class="memdesc:a364ceba90a34ff3c9f4ddbdddea5c3fb"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the index of an available TX slot to be used for nonblocking transmission  <a href="#a364ceba90a34ff3c9f4ddbdddea5c3fb">More...</a><br /></td></tr>
<tr class="separator:a364ceba90a34ff3c9f4ddbdddea5c3fb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab204a599e41fa0d73b37ffec7a3fe908"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#ab204a599e41fa0d73b37ffec7a3fe908">RecvNewMessages</a> ()</td></tr>
<tr class="memdesc:ab204a599e41fa0d73b37ffec7a3fe908"><td class="mdescLeft">&#160;</td><td class="mdescRight">core function for the receive communication task; it wait and receives all new messages  <a href="#ab204a599e41fa0d73b37ffec7a3fe908">More...</a><br /></td></tr>
<tr class="separator:ab204a599e41fa0d73b37ffec7a3fe908"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a6bba0215fd671aab95b2faa1f226ac32"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6bba0215fd671aab95b2faa1f226ac32"></a>
SUBGRAPH_TYPE *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a6bba0215fd671aab95b2faa1f226ac32">dataPtr</a></td></tr>
<tr class="memdesc:a6bba0215fd671aab95b2faa1f226ac32"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to PregelDataContainer object that contains all message buffers <br /></td></tr>
<tr class="separator:a6bba0215fd671aab95b2faa1f226ac32"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7c7ebc29357f7f9b3c2771542ce3f1a5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7c7ebc29357f7f9b3c2771542ce3f1a5"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a7c7ebc29357f7f9b3c2771542ce3f1a5">initFlag</a></td></tr>
<tr class="memdesc:a7c7ebc29357f7f9b3c2771542ce3f1a5"><td class="mdescLeft">&#160;</td><td class="mdescRight">initlialization flag <br /></td></tr>
<tr class="separator:a7c7ebc29357f7f9b3c2771542ce3f1a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3d37e99755d2c3f424f9dcc6ab5ff3d5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3d37e99755d2c3f424f9dcc6ab5ff3d5"></a>
int_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a3d37e99755d2c3f424f9dcc6ab5ff3d5">numDevices</a></td></tr>
<tr class="memdesc:a3d37e99755d2c3f424f9dcc6ab5ff3d5"><td class="mdescLeft">&#160;</td><td class="mdescRight">total number of devices <br /></td></tr>
<tr class="separator:a3d37e99755d2c3f424f9dcc6ab5ff3d5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a85f16a047fc9534ee0e5f05aee4373f7"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a85f16a047fc9534ee0e5f05aee4373f7"></a>
uint64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a85f16a047fc9534ee0e5f05aee4373f7">totalNumVertices</a></td></tr>
<tr class="memdesc:a85f16a047fc9534ee0e5f05aee4373f7"><td class="mdescLeft">&#160;</td><td class="mdescRight">total number of vertices in all devices <br /></td></tr>
<tr class="separator:a85f16a047fc9534ee0e5f05aee4373f7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afdabc98b02e350626161df5225daea5d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="afdabc98b02e350626161df5225daea5d"></a>
uint_fast32_t *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#afdabc98b02e350626161df5225daea5d">timeCountSS</a></td></tr>
<tr class="memdesc:afdabc98b02e350626161df5225daea5d"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to the ss counter <br /></td></tr>
<tr class="separator:afdabc98b02e350626161df5225daea5d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6a4bba59c0f81cb43ead71b9d753c0ea"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6a4bba59c0f81cb43ead71b9d753c0ea"></a>
int_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a6a4bba59c0f81cb43ead71b9d753c0ea">rank</a></td></tr>
<tr class="memdesc:a6a4bba59c0f81cb43ead71b9d753c0ea"><td class="mdescLeft">&#160;</td><td class="mdescRight">MPI rank of the current device. <br /></td></tr>
<tr class="separator:a6a4bba59c0f81cb43ead71b9d753c0ea"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a26bb213989db09c26f68ae5cef6d459f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a26bb213989db09c26f68ae5cef6d459f"></a>
MPI_Request&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a26bb213989db09c26f68ae5cef6d459f">txRequests</a> [NONBLOCKING_TX_THREADS]</td></tr>
<tr class="memdesc:a26bb213989db09c26f68ae5cef6d459f"><td class="mdescLeft">&#160;</td><td class="mdescRight">MPI_Request objectsfor nonBlocking TX. <br /></td></tr>
<tr class="separator:a26bb213989db09c26f68ae5cef6d459f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0f7ac860dbe978ac2158cc9d27c2246f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0f7ac860dbe978ac2158cc9d27c2246f"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a0f7ac860dbe978ac2158cc9d27c2246f">txBusyRequestFlag</a> [NONBLOCKING_TX_THREADS]</td></tr>
<tr class="memdesc:a0f7ac860dbe978ac2158cc9d27c2246f"><td class="mdescLeft">&#160;</td><td class="mdescRight">flags nonBlocking TX <br /></td></tr>
<tr class="separator:a0f7ac860dbe978ac2158cc9d27c2246f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad4c39c5614f6cf8d0b8d17ccbc6ef07f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad4c39c5614f6cf8d0b8d17ccbc6ef07f"></a>
uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#ad4c39c5614f6cf8d0b8d17ccbc6ef07f">txBuffers</a> [NONBLOCKING_TX_THREADS][MAX_MESSAGE_SIZE]</td></tr>
<tr class="memdesc:ad4c39c5614f6cf8d0b8d17ccbc6ef07f"><td class="mdescLeft">&#160;</td><td class="mdescRight">output buffers for the different TX threads <br /></td></tr>
<tr class="separator:ad4c39c5614f6cf8d0b8d17ccbc6ef07f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa17bb7441c8fd71f41dcc778c1c2f9b9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa17bb7441c8fd71f41dcc778c1c2f9b9"></a>
uint_fast32_t *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#aa17bb7441c8fd71f41dcc778c1c2f9b9">dataTxCount</a></td></tr>
<tr class="memdesc:aa17bb7441c8fd71f41dcc778c1c2f9b9"><td class="mdescLeft">&#160;</td><td class="mdescRight">counter for data messages <br /></td></tr>
<tr class="separator:aa17bb7441c8fd71f41dcc778c1c2f9b9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aee1801fc693c654a78cc718c20605dbe"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aee1801fc693c654a78cc718c20605dbe"></a>
uint_fast32_t *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#aee1801fc693c654a78cc718c20605dbe">mutationTxCount</a></td></tr>
<tr class="memdesc:aee1801fc693c654a78cc718c20605dbe"><td class="mdescLeft">&#160;</td><td class="mdescRight">counter for mutation messages <br /></td></tr>
<tr class="separator:aee1801fc693c654a78cc718c20605dbe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a63cc7f893418c8b61888bc652db879a8"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a63cc7f893418c8b61888bc652db879a8"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a63cc7f893418c8b61888bc652db879a8">sysTxCount</a></td></tr>
<tr class="memdesc:a63cc7f893418c8b61888bc652db879a8"><td class="mdescLeft">&#160;</td><td class="mdescRight">counter for system messages <br /></td></tr>
<tr class="separator:a63cc7f893418c8b61888bc652db879a8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a962786d68ebdc61b2365032d15b90762"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a962786d68ebdc61b2365032d15b90762"></a>
<a class="el" href="structMESSAGE__DEV.html">MESSAGE_DEV</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a962786d68ebdc61b2365032d15b90762">devTxMessages</a></td></tr>
<tr class="memdesc:a962786d68ebdc61b2365032d15b90762"><td class="mdescLeft">&#160;</td><td class="mdescRight">message counter for the device messages <br /></td></tr>
<tr class="separator:a962786d68ebdc61b2365032d15b90762"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a60b61c286804c5641bd53cb842c7be93"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a60b61c286804c5641bd53cb842c7be93"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a60b61c286804c5641bd53cb842c7be93">ssComputationEndFlag</a></td></tr>
<tr class="memdesc:a60b61c286804c5641bd53cb842c7be93"><td class="mdescLeft">&#160;</td><td class="mdescRight">flag of the end of the SS execution (no more messages are generated) <br /></td></tr>
<tr class="separator:a60b61c286804c5641bd53cb842c7be93"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0135fc4bb3a5a2606b4adbfe23880502"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0135fc4bb3a5a2606b4adbfe23880502"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a0135fc4bb3a5a2606b4adbfe23880502">ssTxActiveFlag</a></td></tr>
<tr class="memdesc:a0135fc4bb3a5a2606b4adbfe23880502"><td class="mdescLeft">&#160;</td><td class="mdescRight">flag of the end TX for current SS <br /></td></tr>
<tr class="separator:a0135fc4bb3a5a2606b4adbfe23880502"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:add4240f094c016e5e05d96d183409896"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="add4240f094c016e5e05d96d183409896"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#add4240f094c016e5e05d96d183409896">ssRxActiveFlag</a></td></tr>
<tr class="memdesc:add4240f094c016e5e05d96d183409896"><td class="mdescLeft">&#160;</td><td class="mdescRight">flag of the end RX for current SS <br /></td></tr>
<tr class="separator:add4240f094c016e5e05d96d183409896"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5ceb35965f49a6166121346155b5b463"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5ceb35965f49a6166121346155b5b463"></a>
int_fast32_t *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a5ceb35965f49a6166121346155b5b463">rxDevMessageCount</a></td></tr>
<tr class="memdesc:a5ceb35965f49a6166121346155b5b463"><td class="mdescLeft">&#160;</td><td class="mdescRight">holds the number of received messages from each device (incremented with each new message) <br /></td></tr>
<tr class="separator:a5ceb35965f49a6166121346155b5b463"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9f4e571c4c9234481a805c03722b38ad"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9f4e571c4c9234481a805c03722b38ad"></a>
int_fast32_t *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a9f4e571c4c9234481a805c03722b38ad">targetRxDevMessageCount</a></td></tr>
<tr class="memdesc:a9f4e571c4c9234481a805c03722b38ad"><td class="mdescLeft">&#160;</td><td class="mdescRight">holds the target number of messages from each device <br /></td></tr>
<tr class="separator:a9f4e571c4c9234481a805c03722b38ad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a83ce3bedcade3312908d9e8856b2c946"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a83ce3bedcade3312908d9e8856b2c946"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCommunicationManager.html#a83ce3bedcade3312908d9e8856b2c946">txIdleTime</a></td></tr>
<tr class="memdesc:a83ce3bedcade3312908d9e8856b2c946"><td class="mdescLeft">&#160;</td><td class="mdescRight">profiling information for the processing tasks <br /></td></tr>
<tr class="separator:a83ce3bedcade3312908d9e8856b2c946"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename SUBGRAPH_TYPE&gt;<br />
class TIGLCommunicationManager&lt; SUBGRAPH_TYPE &gt;</h3>

<p>core communicator class definition </p>
<p>It handles all the MPI communication between devices (including both system and data messages) It is a template class that is parameterized by </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">SUBGRAPH_TYPE</td><td>the class definition of the data manager object </td></tr>
  </table>
  </dd>
</dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a002a1f09caea60c57aaaf8f320435b26"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::<a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a> </td>
          <td>(</td>
          <td class="paramtype">SUBGRAPH_TYPE *&#160;</td>
          <td class="paramname"><em>dataPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>devices</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>rank</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>overloaded constructor constructor </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dataPtr</td><td>pointer to the data manager object </td></tr>
    <tr><td class="paramname">devices</td><td>total number of devices </td></tr>
    <tr><td class="paramname">rank</td><td>rank of current device </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a6305ea643bdd038b2eabba188809229c"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<div class="memtemplate">
template&lt;typename MESSAGE_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::bytes2Messages </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>rxBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>messageSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">vector&lt; MESSAGE_TYPE &gt; &amp;&#160;</td>
          <td class="paramname"><em>messageBuf</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Convert a sequence of bytes to messages (can be one or more than one messages) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rxBuf</td><td>pointer to bytes to be converted </td></tr>
    <tr><td class="paramname">messageSize</td><td>number of bytes to convert </td></tr>
    <tr><td class="paramname">messageBuf</td><td>message buffer to stored converted messages </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a16cf54ffb11033e7ce47748efca136e0"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::continuousRecvMessages </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>core message receive routine </p>
<p><b>Procedure</b> </p><ol type="1">
<li>Wait until RX is enabled.</li>
<li>Receive all new messages by calling <a class="el" href="classtiglCommunicationManager.html#ab204a599e41fa0d73b37ffec7a3fe908">RecvNewMessages </a>.</li>
<li>Deactivate RX flag </li>
</ol>

</div>
</div>
<a class="anchor" id="a3906aa6920e8e35ae8fa5fe138aace35"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::continuousSendMessages </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>high-level message TX routine </p>
<p><b>Procedure</b> </p><ol type="1">
<li>Wait until TX is enabled.</li>
<li>Continue check and send available messages as long as the superstep computation flag is active.</li>
<li>If the superstep flag becomes inactive, check and send any residual messages.</li>
<li>Send a count of the total number of message to all devices.</li>
<li>Deactivate TX flag. </li>
</ol>

</div>
</div>
<a class="anchor" id="a65d5d5b5f5d5f1a82fbb375d3faacd79"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::countMessages </td>
          <td>(</td>
          <td class="paramtype">uint_fast32_t *&#160;</td>
          <td class="paramname"><em>devMessagesCount</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>count the number of messages to each device </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">devMessagesCount</td><td>pointer to the output buffer that contains the count for each device </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ac383d378b33c25ac6706d77b3ddb1db9"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::endSS </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>called at the end of the superstep to flag the end of message generation </p>
<p>it waits for all TX/RX to complete before going to the superstep barrier </p>

</div>
</div>
<a class="anchor" id="a0b4b3ed59f65b42d13e7f5e41786c9bc"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::existDataMessages2Tx </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>check if there is any new data message to transmit to other devices </p><dl class="section return"><dt>Returns</dt><dd>true if there exists messages, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="aaa8a5a2e7a110cbfaf5293d6aab71961"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::existMutationMessages2Tx </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>check if there is any new mutation message to transmit to other devices </p>
<dl class="section return"><dt>Returns</dt><dd>true if there exists mutation messages, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="ac3bb92c1a0066c0934aebfa6b4fc3866"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::existSysMessages2Tx </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>check if there is any new system message to transmit to other devices </p>
<dl class="section return"><dt>Returns</dt><dd>true if there exists system messages, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="a364ceba90a34ff3c9f4ddbdddea5c3fb"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::findTxSlot </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>returns the index of an available TX slot to be used for nonblocking transmission </p>
<p><b>Procedure</b> </p><ol type="1">
<li>search for any slot that has not been used before, and if any return its index</li>
<li>If all slots have been used before, find any TX slots that finished it nonblocking transmission. </li>
</ol>

</div>
</div>
<a class="anchor" id="a4d3fc1a14e63b16b413695fe3dd433f2"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::init </td>
          <td>(</td>
          <td class="paramtype">SUBGRAPH_TYPE *&#160;</td>
          <td class="paramname"><em>dPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>devices</em> = <code>1</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>devRank</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>initializes the communicator object </p>
<p>it performs all necsssary memory allocations </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dPtr</td><td>pointer to the data container object </td></tr>
    <tr><td class="paramname">devices</td><td>total number of devices </td></tr>
    <tr><td class="paramname">devRank</td><td>rank of the current device </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a7a3f3e74731feba0b7a22e052f7d5aa9"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::initSS </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>initialize the flags of the TX/RX tasks at the start of the superstep </p>
<p>This method must be called at the beginning of each superstep </p>

</div>
</div>
<a class="anchor" id="a980dda0eb9b713f6da87326334c8cd21"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::instRecvMutationMessages </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>dev</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>core function for receiving all mutation messages from a given device </p>
<p>It checks for input MPI messages and routes each mutation message to the local mutation message buffer </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dev</td><td>the source device </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if there exists messages, false otherwise </dd></dl>
<p><b>Procedure</b> </p><ol type="1">
<li>Repeat until no more message exists</li>
</ol>
<ol type="1">
<li>If a message exists, check its size</li>
<li>If the size is bigger than the local buffer, allocate an overflow buffer and read the message to that buffer.</li>
<li>Else read the message to to the local buffer</li>
<li>unpack the messages, and push to the mutation message buffer </li>
</ol>

</div>
</div>
<a class="anchor" id="a53f64b7f8295fc1c5ae23d011d222763"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::isTxComplete </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>check if all TX messages for the current SS is done </p>
<dl class="section return"><dt>Returns</dt><dd>true if TX completed, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="a05204df283d9a53fa26f8ef6c4d9ec53"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::messages2Bytes </td>
          <td>(</td>
          <td class="paramtype">DATA_MESSAGE_BUF_TYPE *&#160;</td>
          <td class="paramname"><em>messagePtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>outBuf</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Convert a group of data messages to a sequence of bytes to be sent. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">messagePtr</td><td>pointer to message buffer </td></tr>
    <tr><td class="paramname">outBuf</td><td>pointer to allocated uint8_t buffer </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>number of bytes consumed </dd></dl>

</div>
</div>
<a class="anchor" id="a45b756eeec6a8167ae98ed17a9b4070a"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::processOneMessage </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>rxBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tag</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>messageSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>dev</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>processing a single received message </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rxBuf</td><td>message buffer </td></tr>
    <tr><td class="paramname">tag</td><td>message tag </td></tr>
    <tr><td class="paramname">messageSize</td><td>messages size in bytes </td></tr>
    <tr><td class="paramname">dev</td><td>source device </td></tr>
  </table>
  </dd>
</dl>
<p><b>Procedure</b> </p>
<ol type="1">
<li>if system message, read and push it to system message buffer.</li>
<li>if data message, read and route to appropriate vertex message buffer. If the destination vertex does not exist send a system error message.</li>
<li>If mutation message, read and route to mutation message buffer.</li>
<li>If a count message, set the target number of message from the source device. </li>
</ol>

</div>
</div>
<a class="anchor" id="ab204a599e41fa0d73b37ffec7a3fe908"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::RecvNewMessages </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>core function for the receive communication task; it wait and receives all new messages </p>
<p><b>Procedure</b> </p><ol type="1">
<li>Initialize all RX slots as available.</li>
<li>While there are messages to receive, do the following steps.</li>
<li>Find all available RX slots, and start a nonblocking receive if a message is available to read.</li>
<li>Find all RX slots that finished receiving, and process the corresponding message using <a class="el" href="classtiglCommunicationManager.html#a45b756eeec6a8167ae98ed17a9b4070a">processOneMessage </a>.</li>
<li>Mark all finished RX slots as available.</li>
<li>If there is no new messages, and the target number of messages is not reached exit with error; otherwise return normally. </li>
</ol>

</div>
</div>
<a class="anchor" id="a7bca269339a42c1afff19d8228d276ed"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::sendDataMessages </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>flushBuffers</em> = <code>false</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>check if there is any new system message to transmit to other devices </p>
<dl class="section return"><dt>Returns</dt><dd>true if there exists system messages, false otherwise </dd></dl>
<p><b>Procedure</b> </p><ol type="1">
<li>Iterate over all data messages</li>
<li>Find the destination device</li>
</ol>
<ol type="1">
<li>Convert the message to bytes and copy it to the local buffer of the target device.</li>
<li>If the buffer is full, find a transmission slot and send the message using nonblocking TX.</li>
<li>update the communication statistics after message transmission </li>
</ol>

</div>
</div>
<a class="anchor" id="a818f1980895110689d07094b2bdb8710"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::sendMutationMessages </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>sending all mutation messages. This is a blocking function </p>
<p><b>Procedure</b> </p>
<ol type="1">
<li>Iterate over all devices</li>
<li>iterate over all messages, and extract mutation messages going to the current device to a local buffer.</li>
<li>If the buffer is full, send its messages to the target device, and clear for refill </li>
</ol>

</div>
</div>
<a class="anchor" id="ae376c35744ea91129ac886f7efffef5a"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::sendSysMessages </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>sending all system messages. This is a blocking function </p>
<p><b>Procedure</b> </p>
<ol type="1">
<li>copying all system messages to a local buffer.</li>
<li>Itarate over all message, if it has code AGGREGATE_INFO, DEV_IDLE, or HALT, broadcast to all devices. Otherwise, send only to target device. </li>
</ol>

</div>
</div>
<a class="anchor" id="a46f40c9bf3a181764e3d113acd33d0de"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::setTimePtr </td>
          <td>(</td>
          <td class="paramtype">uint_fast32_t *&#160;</td>
          <td class="paramname"><em>timePtr</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>initializes the communicator object </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">timePtr</td><td>pointer to the time count </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ae27613519573876dd2782f544a3d99b8"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::taggedBcast </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>txBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>bufSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tag</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>overloaded: sending a single message to a particular destination with a given tag </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">txBuf</td><td>tx buffer </td></tr>
    <tr><td class="paramname">bufSize</td><td>buffer size </td></tr>
    <tr><td class="paramname">tag</td><td>message tag </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a3f14286c0744fb70b2e6a25b176ca5f8"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classtiglCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::waitAllTx </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>waiting for all pending TX messages </p>
<p><b>Procedure</b> </p><ol type="1">
<li>Wait for all data/system/mutation messages</li>
<li>Wait for count messages to all devices </li>
</ol>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/home/mohamed/code/tigl/src/common/communication/<a class="el" href="tiglCommunicationManager_8hpp_source.html">tiglCommunicationManager.hpp</a></li>
<li>/home/mohamed/code/tigl/src/common/communication/<a class="el" href="tiglCommunicationManagerImplementation_8hpp_source.html">tiglCommunicationManagerImplementation.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Mar 3 2015 18:17:04 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
